
c===============================================================================
c				COM_GEO.INC
c===============================================================================

c the geometry:

c all Dy_... and Dz_... values are half of the total extension.
c When read in, all x-positions are relative to the moderator foil but they
c are immediately converted to be relative to the center of the cryostat.

c - moderator:
	real xFoil
	real Dy_Foil, Dz_Foil
	real xEnd_TgtHolder
	real outerDy_TgtHolder  /-1.E10/, outerDz_TgtHolder  /-1.E10/
	real innerDy1_TgtHolder /-1.E10/, innerDy2_TgtHolder /-1.E10/
	real innerDz1_TgtHolder /-1.E10/, innerDz2_TgtHolder /-1.E10/

c - guardring:
	real xStart_Guardring, xEnd_Guardring
	real innerDy_Guardring, outerDy_Guardring
	real innerDz_Guardring, outerDz_Guardring

c - first grid:
	real xPosition_Grid1, distance_wires1, y_Pos_firstWire1 /0./,y_Pos_lastWire1
	real dWires1, rWires1, rQuadWires1
	real xStart_Gridframe1, xEnd_Gridframe1
	real innerDy_Gridframe1, outerDy_Gridframe1
	real innerDz_Gridframe1, outerDz_Gridframe1

	real xStart_Balken, xEnd_Balken
	real Dy_Balken
	real innerDz_Balken, outerDz_Balken

c - second grid:
	real xPosition_Grid2, distance_wires2, y_Pos_firstWire2 /0./,y_Pos_lastWire2
	real dWires2, rWires2, rQuadWires2
	real xStart_Gridframe2, xEnd_Gridframe2
	real innerDy_Gridframe2, outerDy_Gridframe2
	real innerDz_Gridframe2, outerDz_Gridframe2

c - He-shield:
	real      xHeShield	! xHeShield = - xFoil (-> relative Positionen)
	real      rHeShield	! Radius
	real  dy_HeWindow
	real  dz_HeWindow


c x coordinates of beginnings and ends of the individual maps:

	real xStartMap1,xStartMap2,xStartMap3,xStartMap4,xStartMap5,xStartMap6
	real xEndMap1,  xEndMap2,  xEndMap3,  xEndMap4,  xEndMap5,  xEndMap6


c the common blocks:
c (the common blocks /map_%/ are actually bigger. But only the first two
c variables are necessary here)

	COMMON /map_1/ xStartMap1,xEndMap1
	COMMON /map_2/ xStartMap2,xEndMap2
	COMMON /map_3/ xStartMap3,xEndMap3
	COMMON /map_4/ xStartMap4,xEndMap4
	COMMON /map_5/ xStartMap5,xEndMap5
	COMMON /map_6/ xStartMap6,xEndMap6

	COMMON /xFoil/ xFoil

	COMMON /MAP_AND_TGT/
     +	Dy_Foil,Dz_Foil,
     +  xEnd_TgtHolder,outerDy_TgtHolder,outerDz_TgtHolder,
     +  innerDy1_TgtHolder,innerDy2_TgtHolder,innerDz1_TgtHolder,innerDz2_TgtHolder,
     +  xStart_Guardring,xEnd_Guardring,innerDy_Guardring,outerDy_Guardring,
     +  innerDz_Guardring,outerDz_Guardring,
     +  xPosition_Grid1,distance_wires1,dWires1,rQuadWires1,rWires1,
     +  y_Pos_firstWire1,y_Pos_lastWire1,
     +  xStart_Balken,xEnd_Balken,Dy_Balken,
     +  innerDz_Balken,outerDz_Balken,
     +  xStart_Gridframe1,xEnd_Gridframe1,innerDy_Gridframe1,outerDy_Gridframe1,
     +  innerDz_Gridframe1,outerDz_Gridframe1,
     +  xPosition_Grid2,distance_wires2,dWires2,rQuadWires2,rWires2,
     +  y_Pos_firstWire2,y_Pos_lastWire2,
     +  xStart_Gridframe2,xEnd_Gridframe2,innerDy_Gridframe2,outerDy_Gridframe2,
     +  innerDz_Gridframe2,outerDz_Gridframe2,
     +  xHeShield,rHeShield,dy_HeWindow,dz_HeWindow 

