
c===============================================================================
c				GEO_TRIGGER.INC
c===============================================================================

c*******************************************************************************
c*									       *
c*   Diese Datei enthaelt die geometrischen Daten des NEMU-Triggerdetektors    *
c*   in seiner ersten Version.						       *
c*									       *
c*   Die Definitionen der Groessen sind im Ordner 'MUTRACK' niedergelegt!      *
c*   Alle Angaben sind in [mm].					               *
c*									       *
c*   Stand: Run VI. Die Werte wurden einer Konstruktionszeichnung entnommen    *
c*									       *
c*   >>  2.12.1994		>>  ahofer@psiclu.cern.ch		       *
c*									       *
c*******************************************************************************


c Laengen in x-Richtung:

        real dx1,dx2,dx3,dx4,dx5,dx6,dx7,dx8,dx9,dx10,dx11

	parameter (dx1 = 8, dx2 =37, dx3 =14, dx4 =42, !dx5 = 8,
     +             dx6 =12, dx7 =12, dx8 =19, dx9 =23, dx10=10, dx11=14)

	DATA dx5 / 8 /
	COMMON /dx5/ dx5

c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

c Laengen in y-Richtung:

        real dy1,dy2,dy3,dy4,dy5,dy6,dy7,dy8,dy9,dy10,dy11
        real dy12,dy13,dy14,dy15     

	parameter (dy1 =20, dy2 =20, dy3 =25, dy4 =25, dy5 =25,
     +		   dy6 =32, dy7 =30, dy8 =42, dy9 =40, dy10=11,
     +		   dy11=32, dy12=30, dy13=30, dy14=30, dy15=30)


c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

c Laengen in z-Richtung:

	real dz1, dz2

	parameter (dz1 =30, dz2 =30)


c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

	real d_Grid_Folie				! Abstand zwischen
	parameter (d_Grid_Folie = 18)			! Gitter und Folie

c Abgeleitete Laengen:

	real d_Folie_Achse				! Abstand zwischen Folie
	parameter (d_Folie_Achse  = dx1+dx2+dx3/2)	! und Trigger-Achse

	real d_Folie_Hinten2				! Abstand zwischen Folie
	parameter (d_Folie_Hinten2 = dx1+dx2+dx3+dx4)	! und 2. Gitter von H

	real radiusQuad_Folie				! in MUTRACK.INPUT?
	parameter (radiusQuad_Folie = 20*20 )

	real radiusQuad_Folie_max			! <------ nicht benutzt!
	parameter (radiusQuad_Folie_max = 26*26)	! maximaler Folienradius

	real xCenter_MCP3, radius_MCP3, radiusQuad_MCP3
	parameter (radius_MCP3     = ((dx2+dy8-dx11)-(dx9))/2. )
	parameter (radiusQuad_MCP3 = radius_MCP3 * radius_MCP3)
	parameter (xCenter_MCP3    = dx1+dx9+radius_MCP3)	! x-Pos. der Mitte von
							! MCP3 im Triggersystem
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

c Gitterdrahtabstaende und -durchmesser:
c (Nachdem diese Groessen in Run 10 geaendert wurden muessen sie nun als
c Variable gehandhabt werden)

	real dist_Wires_V1 /1.5/, dWires_V1 /.050/
	real dist_Wires_V2 /1.5/, dWires_V2 /.050/
	real dist_Wires_V3 /1.5/, dWires_V3 /.050/
	real dist_Wires_H1 /1.5/, dWires_H1 /.050/
	real dist_Wires_H2 /1.5/, dWires_H2 /.050/
	real dist_Wires_G  /1.5/, dWires_G  /.050/

	real WireRadiusQuad_V1, WireRadiusQuad_V2, WireRadiusQuad_V3
	real WireRadiusQuad_H1, WireRadiusQuad_H2, WireRadiusQuad_G

	COMMON /TD_GEO/
     +	    dist_Wires_V1,dist_Wires_V2,dist_Wires_V3,
     +	    dist_Wires_H1,dist_Wires_H2,dist_Wires_G, 
     +	    dWires_V1,dWires_V2,dWires_V3,dWires_H1,dWires_H2,dWires_G,
     +      WireRadiusQuad_V1,WireRadiusQuad_V2,WireRadiusQuad_V3,
     +	    WireRadiusQuad_H1,WireRadiusQuad_H2,WireRadiusQuad_G

c	parameter (dist_Wires_V1 = 1.5 ,  dWires_V1 = .050)
c	parameter (dist_Wires_V2 = 1.5 ,  dWires_V2 = .050)
c	parameter (dist_Wires_V3 = 1.5 ,  dWires_V3 = .050)
c	parameter (dist_Wires_H1 = 1.5 ,  dWires_H1 = .050)
c	parameter (dist_Wires_H2 = 1.5 ,  dWires_H2 = .050)
c	parameter (dist_Wires_G  = 1.5 ,  dWires_G  = .050)


c die Berechnung der Quadrate wird jetzt in SUBROUTINE READ_TRIGGER_GEO erledigt
c
c	parameter (WireRadiusQuad_V1 = dwires_V1*dWires_V1/4.,
c    +		   WireRadiusQuad_V2 = dwires_V2*dWires_V2/4.,
c    +		   WireRadiusQuad_V3 = dwires_V3*dWires_V3/4.,
c    +		   WireRadiusQuad_H1 = dwires_H1*dWires_H1/4.,
c    +		   WireRadiusQuad_H2 = dwires_H2*dWires_H2/4.,
c    +		   WireRadiusQuad_G  = dwires_G *dWires_G /4.)

c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

c Effizienz von MCP3:

	real efficiencyM3
	parameter (efficiencyM3 = .75)
c	parameter (efficiencyM3 = .50)

